<?php
/**
 * ------------------------------------------------------------------------
 * JA T3v3 System Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// No direct access
defined('_JEXEC') or die();
t3v3import ('core/template');
jimport('joomla.utilities.utility');
/**
 * T3V3Template class provides extended template tools used for T3v3 framework
 *
 * @package T3V3
 */
class T3v3TemplateLayout extends T3v3Template
{
	protected $_block = null;
	/**
	 * Class constructor
	 *
	 * @param   object  $template Current template instance
	 */
	public function __construct($template = null)
	{
		parent::__construct($template);
		$this->setParam('responsive', 0);
	}

	/**
	* Get current layout tpls
	*
	* @return string Layout name
	*/
	public function getLayout () {
		return JRequest::getCmd ('t3layout', $this->_tpl->params->get('mainlayout'));
	}
  
    function countModules($positions)
    {
    	$pos = $this->getPosname ($positions);
        return 1;
    }
  
	/**
	* Load block content
	*
	* @param $block string
	*     Block name - the real block is tpls/blocks/[blockname].php
	*
	* @return string Block content
	*/
	function loadBlock($block, $vars = array())
	{
		if (!$this->_block){
			$this->_block = $block;
		}

		$path = T3V3Path::getPath ('tpls/system/'.$block.'.php');
		if(!$path){
			$path = T3V3Path::getPath ('tpls/blocks/'.$block.'.php');
		}
		
		ob_start();
		if ($path) {
			include $path;
		} else {
			echo "<div class=\"error\">Block [$block] not found!</div>";
		}
		$content = ob_get_contents();
		ob_end_clean();

		if ($this->_block == $block || isset($vars['spl'])) {
			$content = preg_replace ('#(<[A-Za-z]+[^>^\/]*)>#', '\1 data-original="' . $block . '"' . (isset($vars['spl']) ? ' data-spotlight="' . $vars['name'] . '"' : '') . '>', $content, 1);
			$this->_block = null;
		}
		
		echo isset($vars['spl']) ? $content : ("<div class=\"ja-layout-section\">".$content."</div>");
	} 

	/**
	* Load block content
	*
	* @param $block string
	*     Block name - the real block is tpls/blocks/[blockname].php
	*
	* @return string Block content
	*/
	function loadLayout($layout)
	{
		$path = T3V3_TEMPLATE_PATH . '/tpls/'.$layout.'.php';
		if (!is_file ($path)) {
			$path = T3V3_TEMPLATE_PATH . '/tpls/default.php';
		}

		if (is_file ($path)) {
			// include $path;
			$html = $this->loadFile ($path);

			// parse and replace jdoc
			$html = $this->_parse ($html);
			echo $html;
		} else {
			echo "<div class=\"error\">Layout [$layout] or [Default] not found!</div>";
		}
	}

	function spotlight($name, $default_pos, $default_width = '')
	{
		$vars['name'] = $name;
		$vars['pos'] = $this->getParam (T3V3_LAYOUT_PREFIX.$name.'_pos', $default_pos);
		$vars['defpos'] = $default_pos;
		$vars['width'] = $this->getParam (T3V3_LAYOUT_PREFIX.$name.'_width', $default_width);
		$vars['spl'] = 1;
		$this->loadBlock ('spotlight', $vars);
	}

	function posname ($condition) {
		echo $this->getPosname ($condition) . '" data-original="'.$condition;
	}

	protected function _parse($html)
	{
		$html = preg_replace_callback('#<jdoc:include\ type="([^"]+)" (.*)\/>#iU', array($this, '_parseJDoc'), $html);
		return $html;		
	}

	protected function _parseJDoc ($matches) {
		$type = $matches[1];
		if ($type == 'head') {
			return $matches[0];
		} 
		$attribs = empty($matches[2]) ? array() : JUtility::parseAttributes($matches[2]);
		$attribs['type'] = $type;
		if (!isset($attribs['name'])){
			$attribs['name'] = $attribs['type'];
		}

		$tp = 'tpls/system/tp.php';
		$path = '';
		if (is_file (T3V3_TEMPLATE_PATH . '/' . $tp)) {
			$path = T3V3_TEMPLATE_PATH . '/' . $tp;
		} else if (is_file (T3V3_PATH . '/' . $tp)) {
			$path = T3V3_PATH . '/' . $tp;
		}

		return $this->loadFile ($path, $attribs);
	}

	function loadFile ($path, $vars = array()) {
		ob_start();
		include $path;
		$content = ob_get_contents();
		ob_end_clean();
		return $content;
	}

	/**
	* Add T3v3 basic head 
	*/
	function addHead () {
		// BOOTSTRAP CSS
		$this->addCss ('bootstrap'); 
		$this->addCss ('layout-custom'); 

		// Add scripts
		$this->addScript (T3V3_URL.'/bootstrap/js/jquery.js');
		$this->addScript (T3V3_URL.'/bootstrap/js/bootstrap.js');
	}
}
?>