<?php
/**
 * ------------------------------------------------------------------------
 * JA T3v3 System Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

// No direct access
defined('_JEXEC') or die();
t3v3import ('core/template');

/**
 * T3V3Template class provides extended template tools used for T3v3 framework
 *
 * @package T3V3
 */
class T3v3TemplatePos extends T3v3Template
{
	protected $_positions = array();
	protected $_block = '';
	/**
	 * Class constructor
	 *
	 * @param   object  $template Current template instance
	 */
	public function __construct($template = null)
	{
		parent::__construct($template);
	}

	/**
	* Get current layout tpls
	*
	* @return string Layout name
	*/
	public function getLayout () {
		return JRequest::getCmd ('t3layout', $this->_tpl->params->get('mainlayout'));
	}
	

	/**
	* Load block content
	*
	* @param $block string
	*     Block name - the real block is tpls/blocks/[blockname].php
	*
	* @return string Block content
	*/
	function loadLayout($layout)
	{
		ob_start();
		parent::loadLayout ($layout);
		$pos = $this->getPositions ();
		ob_end_clean();
		echo json_encode($this->getPositions());
		exit();
	} 

	function loadBlock($block, $data = '')
	{
		$_block = $this->_block;
		if (!$this->_block) $this->_block = $block;
		// parent::loadBlock ($block, $data);
		$path = T3V3Path::getPath ('tpls/blocks/'.$block.'.php');
		if ($path) {
			include $path;
		}

		$this->_block = $_block;
	}
	
	function spotlight($name, $default_pos, $default_width = '') {
		$this->_positions [$name] = array();
		$this->_positions [$name]['spotlight'] = 1;
		$this->_positions [$name]['pos'] = $this->getParam (T3V3_LAYOUT_PREFIX.$name.'_pos', $default_pos);
		$this->_positions [$name]['width'] = $this->getParam (T3V3_LAYOUT_PREFIX.$name.'_width', $default_width);
	}

	function getPositions () {
		return $this->_positions;
	}

	function getPosname ($condition) {
		$operators = '(,|\+|\-|\*|\/|==|\!=|\<\>|\<|\>|\<=|\>=|and|or|xor)';
		$words = preg_split('# ' . $operators . ' #', $condition, null, PREG_SPLIT_DELIM_CAPTURE);
		for ($i = 0, $n = count($words); $i < $n; $i += 2)
		{
			// odd parts (modules)
			$name = strtolower($words[$i]);
			$words[$i] = $this->getParam (T3V3_LAYOUT_PREFIX.$name, $name);
			$block = $this->_block ? $this->_block : 'default';
			if (!isset($this->_positions[$block])) $this->_positions[$block] = array();
			$this->_positions[$block][$name] = $words[$i];
		}

		$poss = implode(' ', $words);
		return $poss;
	}
	
    function countModules($positions) {
    	return 1;
    }

}
?>