/**
 * ------------------------------------------------------------------------
 * JA T3v3 System Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

!function($){

	var JADepend = window.JADepend = window.JADepend || { 	
		
		depends: {},
		controls: {},
		ajaxs: {},

		register: function(to, depend){
			var controls = this.controls;
			
			if(!controls[to]){
				controls[to] = [];
				
				var inst = this;
				this.elmsFrom(to).on('change.less', function(e){
					inst.change(this);
				});
			}
			
			if($.inArray(depend, controls[to]) == -1){
				controls[to].push(depend);
			}
		},
		
		change: function(ctrlelm){
			var controls = this.controls,
				depends = this.depends,
				ctrls = controls[ctrlelm.name],
				form = this;

				
			if(!ctrls){
				ctrls = controls[ctrlelm.name.substr(ctrlelm.name.length - 2)];
			}
			
			if(!ctrls){
				return false;
			}
			
			$.each(ctrls, function(){
				var showup = true;
				
				$.each(depends[this], function(ctrl, cvals){
					if(showup){
						var celms = form.elmsFrom(ctrl);
						showup = showup && !!($.grep(celms, function(celm){ return celm._disabled; }).length == 0);
						if(showup){
							showup = showup && !!($.grep(form.valuesFrom(celms), function(val){ return ($.inArray(val, cvals) != -1); }).length);
						}
					}
				});
				
				form.elmsFrom(this).each(function(){
					if(showup){
						form.enable(this);
					} else {
						form.disable(this);
					}
				});
				
				if(controls[this] && controls[this] != this){
					form.elmsFrom(this).eq(0).trigger('change');
				}
				
			});
		},
		
		add: function(control, info){
			
			var depends = this.depends,
				form = this,
				name = info.group + '[' + control + ']';
				
			info = $.extend({
				group: 'params',
				control: name
			}, info);
			
			$.each(info.elms.split(','), function(el){
				var elm = info.group +'[' + $.trim(this) + ']';
				
				if (!depends[elm]) {
					depends[elm] = {};
				}
				
				if (!depends[elm][name]) {
					depends[elm][name] = [];
				}
				
				depends[elm][name].push(info.val);
				
				form.register(name, elm);
				
			});
		},
		
		start: function(){
			$(document.adminForm).find('h4.block-head').parent().addClass('segment');
			
			this.update();
		},
		
		update: function () {
			var form = this;
			$.each(this.controls, function(ctrl, ctrls){
				form.elmsFrom(ctrl).trigger('change');
			});
		},
		
		enable: function (el) {
			el._disabled = false; //selector 'li' is J2.5 compactible
			$(el).closest('li, div.control-group').css('display', 'block');
		},
		
		disable: function (el) {
			el._disabled = true; //selector 'li' is J2.5 compactible
			$(el).closest('li, div.control-group').css('display', 'none');
		},
		
		elmsFrom: function(name){
			var el = document.adminForm[name];
			if(!el){
				el = document.adminForm[name + '[]'];
			}
			
			return $(el);
		},
		
		valuesFrom: function(els){
			var vals = [];
			
			$(els).each(function(){
				var type = this.type,
					val = $.makeArray(((type == 'radio' || type == 'checkbox') && !this.checked) ? null : $(this).val());

				for (var i = 0, l = val.length; i < l; i++){
					if($.inArray(val[i], vals) == -1){
						vals.push(val[i]);
					}
				}
			});
			
			return vals;
		},

		addajax: function(name, info){
			var ajaxs = this.ajaxs;
				
			info = $.extend({
				url: window.location.href,
				langsprefix: 'T3V3_'
			}, info);

			if(info.query){
				var urlparts = info.url.split('#');
				if(urlparts[0].indexOf('?') == -1){
					urlparts[0] += '?' + info.query;
				} else {
					urlparts[0] += '&' + info.query;
				}
				
				info.url = urlparts.join('#');
			}

			if(!ajaxs[name]){
				ajaxs[name] = {};

				var inst = this;
				ajaxs[name].uid = 0;
				ajaxs[name].indicator = this.elmsFrom(name).on('change.less', function(e){
					inst.loadajax(this);
				}).after('' +
					'<div class="progress progress-striped progress-mini active">' +
						'<div class="bar" style="width: 100%"></div>' +
					'</div>').next().hide();
			}

			ajaxs[name].info = info;
		},

		loadajax: function(ctrlelm){
			var ajaxs = this.ajaxs,
				name = ctrlelm.name,
				ctrl = ajaxs[name],
				form = this;

			if(!ctrl){
				ctrl = ajaxs[name.substr(name.length - 2)];
			}
			
			if(!ctrl){
				return false;
			}

			var info = ctrl.info;
			if(!info){
				return false;
			}

			if(ctrl.elms && ctrl.elms.length){
				$(ctrl.elms).remove();
				ctrl.elms.length = 0;
			} else {
				ctrl.elms = [];
			}

			if(ctrl.indicator.next('.chzn-container').length){
				ctrl.indicator.insertAfter(ctrl.indicator.next('.chzn-container'));
			}

			ctrl.indicator.show();
			$.get(info.url, { t3layout: form.valuesFrom(form.elmsFrom(name))[0] }, function(rsp){
				ctrl.indicator.hide();

				if(rsp){
					var bdhtml = rsp.match(/<body[^>]*>([\w|\W]*)<\/body>/im),
						vname = name.replace(/[\[\]]/g, '');

					if(bdhtml){
						var jtabpane = $('#jformparamsjat3_all_pos').closest('.tab-pane'),
							active = jtabpane.hasClass('active');
						if(!active){	//if not active, then we show it
							jtabpane.addClass('active');
						}

						var	curspan = null,
							sid = null,
							jcontrol = $('<div class="control-group">' +
												'<div class="control-label">' +
													'<label class="hasTip" title="Layout Configurations">Layout Configurations</label>' + 
												'</div>' +
												'<div class="controls">' +
												'</div>' +
											'</div>').insertAfter($('#jformparamsjat3_all_pos').closest('.control-group')),
							jelms = $('<div class="t3cont layout-custom ' + vname + '"></div>').html(bdhtml[0]).appendTo(jcontrol.find('.controls')),
							jallpos = $('#jformparamsjat3_all_pos').clone().attr({
								'id': 'jaa_sel_' + ctrl.uid++,
								'name': '',
								'class': 'chosen-prepare',
								'style': '',
							}),
							jselect = $('' +
								'<div class="popover right" style="z-index: 99">' +
									'<div class="arrow"></div>' +
									'<h3 class="popover-title">' + T3V3Admin.langs.popoverLayoutTitle + '</h3>' +
									'<div class="popover-content">' +
										(T3V3Admin.langs.popoverLayoutDesc ? '<p>' + T3V3Admin.langs.popoverLayoutDesc + '</p>' : '' ) +
									'</div>' +
								'</div>)').appendTo(document.body)
							.on('click', function(e){
								return false;
							});


						jselect.find('.popover-content').append(
							jallpos
							.prop('disabled', false)
							.prop('size', 10)
							.on('change', function(){
								if(curspan){
									$(curspan).parent().removeClass('pos-off pos-active').find('h3').html(this.value || T3V3Admin.langs.emptyLayoutPosition);
									$(this).closest('.popover').hide();

									if(!this.value){
										$(curspan).parent().addClass('pos-off');
									}

									$(this)
										.next('.ja-chzn-empty')[this.value ? 'removeClass' : 'addClass']('disabled')
										.next('.ja-chzn-default')[this.value != $(curspan).closest('[data-original]').attr('data-original') ? 'removeClass' : 'addClass']('disabled');
								}

								return false;
							})
						);

						ctrl.elms.push(jselect[0]);

						$(document).off('click.' + vname).on('click.' + vname, function(){
							if(curspan){
								$(curspan).parent().removeClass('pos-active');
							}

							jselect.hide();
						});

						jallpos
							.after('' +
								'<btn class="btn btn-small ja-chzn-empty" style="margin-right: 10px;"><i class="icon-remove"></i>' + T3V3Admin.langs.emptyLayoutPosition + '</btn>' +
								'<btn class="btn btn-small btn-success ja-chzn-default"><i class="icon-ok-circle"></i>' + T3V3Admin.langs.defaultLayoutPosition + '</btn>')
							.nextAll('.ja-chzn-empty, .ja-chzn-default')
							.on('click', function(){
								if(curspan && !$(this).hasClass('disabled')){
									var vdef = $(this).hasClass('ja-chzn-default') ? $(curspan).closest('[data-original]').attr('data-original') : '';
									jallpos.val(vdef).trigger('change');
								}

								return false;
							});

						jelms
							.find('.logo h1:first')
							.html(T3V3Admin.langs.logoPresent);

						jelms
							.find('.ja-layout-pos')
							.not('.block-message, .block-component')
							.prepend('<span class="t3layout-edit"><i class="icon-cog"></i></span>');

						jelms
							.find('.ja-layout-pos')
							.find('h3, h1')
							.addClass('t3layout-posname')
							.attr('title', T3V3Admin.langs.layoutPosName)
							.each(function(){
								var jparent = $(this).parentsUntil('.row').last(),
									span = parseInt(jparent.prop('className').replace(/(.*?)span(\d+)(.*)/, "$2"));

								if(isNaN(span)){
									span = T3V3Admin.langs.layoutUnknownWidth;
								}

								$(this).before('<span class="t3layout-poswidth" title="' + T3V3Admin.langs.layoutPosWidth + '">' + span + '</span>');
							});

						jelms.on('click', '.t3layout-edit', function(e){
							if(curspan){
								$(curspan).parent().removeClass('pos-active');
							}

							curspan = this;
							var jspan = $(this),
								offs = $(this).offset();

							jspan.parent().addClass('pos-active');
							jselect.removeClass('top').addClass('right');

							var top = offs.top + (jspan.height() - jselect.height()) / 2,
								left = offs.left + jspan.width();

							if(left + jselect.outerWidth(true) > $(window).width()){
								jselect.removeClass('right').addClass('top');
								top = offs.top - jselect.outerHeight(true);
								left = offs.left + (jspan.width() - jselect.width()) / 2;
							}

							jselect.css({
								top: top,
								left: left
							}).show()
								.find('select')
								.val(jspan.siblings('h3').html())
								.next('.ja-chzn-empty')[jallpos.val() ? 'removeClass' : 'addClass']('disabled')
								.next('.ja-chzn-default')[jspan.siblings('h3').html() != jspan.closest('[data-original]').attr('data-original') ? 'removeClass' : 'addClass']('disabled');

							jallpos.scrollTop(Math.min(jallpos.prop('scrollHeight') - jallpos.height(), jallpos.prop('selectedIndex') * (jallpos.prop('scrollHeight') / jallpos[0].options.length)));
							
							return false;
						}).find('.row')
							.filter('[data-spotlight]')
							.each(function(){

							var jncols = $('' +
										'<div class="btn-group t3layout-ncolumns">' +
											'<span class="btn">1</span>' +
											'<span class="btn">2</span>' +
											'<span class="btn">3</span>' +
											'<span class="btn">4</span>' +
											'<span class="btn">5</span>' +
											'<span class="btn">6</span>' +
										'</div>').appendTo(this.parentNode),
								spotlight = this,
								jcols = $(this).children().addClass('t3layout-unit'),
								jtest = $('<div class="span1"></div>').appendTo(this),
								mgLeft = parseInt($(this).css('marginLeft')),
								absMgLeft = Math.abs(mgLeft),
								gridsize = jtest.width() + absMgLeft,
								numcol = jcols.length,
								nid = null,
								cwidths = [],
								cpositions = [],
								cdefpos = [];

							jtest.remove();
							
							$(spotlight).parent().addClass('t3layout-splgroup');

							jcols.each(function(idx){
								cwidths[idx] = parseInt(this.className.replace(/(.*?)span(\d+)(.*)/, "$2"));
								cpositions[idx] = $(this).find('h3').html();
								cdefpos[idx] = $(this).data('data-original');						
							});

							for(var i = numcol; i < 6; i++){
								cpositions.push(T3V3Admin.langs.emptyLayoutPosition);
								cdefpos.push(T3V3Admin.langs.emptyLayoutPosition);
							}

							jncols.on('click', '.btn', function(e){

								//process add or remove columns
								if(!e.isTrigger){
									var ncol = $(this).index() + 1,
										i, html, avg = Math.floor(12 / ncol);

									for(i = 0; i < ncol -1; i++){
										cwidths[i] = avg;
									}

									cwidths[ncol -1] = (12 - avg * (ncol -1));
									numcol = ncol;
								
									html = '';
									for(i = 0; i < numcol; i++){
										html += '' +
										'<div class="t3layout-unit span' + cwidths[i] + '">' +
											'<div class="ja-layout-pos block-' + cpositions[i] + (cpositions[i] == T3V3Admin.langs.emptyLayoutPosition ? ' pos-off' : '') + '" data-original="' + (cdefpos[i] || '') + '">' +
												'<span class="t3layout-edit"><i class="icon-cog"></i></span>' +
												'<span class="t3layout-poswidth" title="' + T3V3Admin.langs.layoutPosWidth + '">' + cwidths[i] + '</span>' +
												'<h3 class="t3layout-posname" title="' + T3V3Admin.langs.layoutPosName + '">' + cpositions[i] + '</h3>' +
											'</div>' +
										'</div>';
									}

									$(spotlight)
										.attr('id', '')
										.removeClass('JColResizer')
										.html(html)
										.prev('.JCLRgrips').remove();

									jcols = $(spotlight).children();

									$(this).addClass('active').siblings().removeClass('active');
								}

								$(spotlight).colResizable({
									liveDrag: true,
									minWidth: (gridsize  << 1),
									marginLeft: mgLeft,
									selector: '> .t3layout-unit',
									onDrag: function(e, d){
										var idx = d.index(),
											cspan = (jcols.eq(idx).width() + absMgLeft) / gridsize,
											vspan = (jcols.eq(idx + 1).width() + absMgLeft) / gridsize;

										if((cspan * 10 % 10 == 5) && (vspan * 10 % 10 == 5)){
											cspan = Math.ceil(cspan);
											vspan = Math.floor(vspan);
										} else {
											cspan = Math.round(cspan);
											vspan = Math.round(vspan);
										}

										jcols.eq(idx).find('.t3layout-poswidth').html(cspan);
										jcols.eq(idx + 1).find('.t3layout-poswidth').html(vspan);
									},
									onResize: function(e, d){
										var idx = d.index(),
											cspan = (jcols.eq(idx).width() + absMgLeft) / gridsize,
											vspan = (jcols.eq(idx + 1).width() + absMgLeft) / gridsize;

										if((cspan * 10 % 10 == 5) && (vspan * 10 % 10 == 5)){
											cspan = Math.ceil(cspan);
											vspan = Math.floor(vspan);
										} else {
											cspan = Math.round(cspan);
											vspan = Math.round(vspan);
										}

										jcols.eq(idx).width(cspan * gridsize + mgLeft).find('.t3layout-poswidth').html(cspan);
										jcols.eq(idx + 1).width(vspan * gridsize + mgLeft).find('.t3layout-poswidth').html(vspan);
									
										var gripleft = 0;
										for(var i = 0; i <= idx; i++){
											gripleft += jcols.eq(i).outerWidth(true);
										}

										d.css('left', gripleft);
									}
								});
							}).children().removeClass('active').eq(numcol -1).addClass('active').trigger('click');
						});

						if(!active){	//restore current status
							jtabpane.removeClass('active');
						}

						ctrl.elms.push(jcontrol[0]);
					}
				}
			});
		},
		
		segment: function(seg){
			if($(seg).hasClass('close')){
				this.showseg(seg);
			} else {
				this.hideseg(seg);
			}
		},
		
		showseg: function(seg){
			
			var segelm = $(seg),
				snext = segelm.parent().next();
			
			while(snext.length && !snext.hasClass('segment')){
				snext.css('display', snext.data('jdisplay') || '');
				snext = snext.next();
			}
			
			segelm.removeClass('close').addClass('open');
		},
		
		hideseg: function(seg){
			var segelm = $(seg),
				snext = segelm.parent().next();
			
			while(snext.length && !snext.hasClass('segment')){
				snext.data('jdisplay', snext.css('display')).css('display', 'none');
				snext = snext.next();
			}
			
			segelm.removeClass('open').addClass('close');  
		}
	};

	var JAFileConfig = window.JAFileConfig = window.JAFileConfig || {
		
		vars: {
		},
		
		initialize: function(optionid){
			var vars = this.vars;
			vars.group = 'jaform';
			vars.el = document.getElementById(optionid);
			
			var adminlist = $('#module-sliders').find('ul.adminformlist:first');
			if(adminlist.length){
				$('<li class="clearfix level2"></li>').appendTo(adminlist);
			}
		},
		
		changeProfile: function(profile){
			if(profile == ''){
				return;
			}
			
			this.vars.active = profile;
			this.fillData();
			
			if(JADepend && JADepend.update){
				JADepend.update();
			}
		},
		
		serializeArray: function(){
			var vars = this.vars,
				els = [],
				allelms = document.adminForm.elements,
				pname1 = vars.group + '\\[params\\]\\[.*\\]',
				pname2 = vars.group + '\\[params\\]\\[.*\\]\\[\\]';
				
			for (var i = 0, il = allelms.length; i < il; i++){
			    var el = $(allelms[i]);
				
			    if (el.name && ( el.name.test(pname1) || el.name.test(pname2))){
			    	els.push(el);
			    }
			}
			
			return els;
		},

		fillData: function (){
			var vars = this.vars,
				els = this.serializeArray(),
				profile = JADepend.profiles[vars.active],
				form = this;
				
			if(els.length == 0 || !profile){
				return;
			}
			
			$.each(els, function(){
				var name = this.getName(this),
					values = (profile[name] != undefined) ? profile[name] : '';
				
				form.setValues(this, $.makeArray(values));
			});
		},
		
		valuesFrom: function(els){
			var vals = [];
			
			$(els).each(function(){
				var type = this.type,
					val = $.makeArray(((type == 'radio' || type == 'checkbox') && !this.checked) ? null : $(this).val());

				for (var i = 0, l = val.length; i < l; i++){
					if($.inArray(val[i], vals) == -1){
						vals.push(val[i]);
					}
				}
			});
			
			return vals;
		},
		
		setValues: function(el, vals){
			var jel = $(el);
			
			if(jel.prop('tagName').toUpperCase() == 'SELECT'){
				jel.val(vals);
				
				if($.makeArray(jel.val())[0] != vals[0]){
					jel.val('-1');
				}
			}else {
				if(jel.prop('type') == 'checkbox' || jel.prop('type') == 'radio'){
					jel.prop('checked', $.inArray(el.value, vals) != -1);
				} else {
					jel.attr('placeholder', vals[0]);
					jel.val(vals[0]);
				}
			}
		},
		
		getName: function(el){
			var matches = el.name.match(this.vars.group + '\\[params\\]\\[([^\\]]*)\\]');
			if (matches){
				return matches[1];
			}
			
			return '';
		},
		
		
		deleteProfile: function(){
			if(confirm(JAFileConfig.langs.confirmDelete)){			
				this.submitForm(JAFileConfig.mod_url + '?jaction=delete&profile=' + this.vars.active + '&template='+ JAFileConfig.template, {}, 'profile');
			}		
		},
		
		duplicateProfile: function (){
			var nname = prompt(JAFileConfig.langs.enterName);
			
			if(nname){
				nname = nname.replace(/[^0-9a-zA-Z_-]/g, '').replace(/ /, '').toLowerCase();
				if(nname == ''){
					alert(JAFileConfig.langs.correctName);
					return this.cloneProfile();
				}
				
				JAFileConfig.profiles[nname] = JAFileConfig.profiles[this.vars.active];
				
				this.submitForm(JAFileConfig.mod_url + '?jaction=duplicate&profile=' + nname + '&from=' + this.vars.active + '&template=' + JAFileConfig.template, {}, 'profile');
			}
		},
		
		saveProfile: function (task){

			if(task){
				JAFileConfig.profiles[this.vars.active] = this.rebuildData();
				this.submitForm(JAFileConfig.mod_url + '?jaction=save&profile=' + this.vars.active, JAFileConfig.profiles[this.vars.active], 'profile', task);
			}
		},
		
		submitForm: function(url, request, type, task){
			if(JAFileConfig.run){
				JAFileConfig.ajax.cancel();
			}
			
			JAFileConfig.run = true;
	    	
			JAFileConfig.ajax = $.ajax({
				type: 'post',
				url: url,
				data: request,
				complete: function(result){
					
					JAFileConfig.run = false;
					
					if(result == ''){
						return;
					}
					
					var vars = JAFileConfig;
					
					alert(json.error || json.successfull);
					
					if(result.profile){
						switch (result.type){	
							case 'new':
								Joomla.submitbutton(document.adminForm.task.value);
							break;
							
							case 'delete':
								if(result.template == 0){
									var opts = vars.el.options;
									
									for(var j = 0, jl = opts.length; j < jl; j++){
										if(opts[j].value == result.profile){
											vars.el.remove(j);
											break;
										}
									}
								} else {
									JAFileConfig.profiles[result.profile] = JAFileConfig.tempprofiles[result.profile];
								}
								
								vars.el.options[0].selected = true;					
								JAFileConfig.changeProfile(vars.el.options[0].value);
							break;
							
							case 'duplicate':
								vars.el.options[vars.el.options.length] = new Option(result.profile, result.profile);							
								vars.el.options[vars.el.options.length - 1].selected = true;
								JAFileConfig.changeProfile(result.profile);
							break;
							
							default:
						}
					}
				}
			});
		},
		
		rebuildData: function (){
			var els = this.serializeArray(this.group),
				form = this,
				json = {};
				
			$.each(els, function(){
				var values = form.valuesFrom(this);
				if(values.length){
					json[this.getName(this)] = this.name.substr(-2) == '[]' ? values : values[0];
				}
			});
			
			return json;
		}
	};

	$(window).on('load', function() {
		setTimeout($.proxy(JADepend.start, JADepend), 100);
	});

}(window.$ja || window.jQuery);

